Hex Artifact Content

Artifact 99ffc9d1a8addce8634c51a4ea7da3044c4f15a9:


0000: 23 21 20 2f 75 73 72 2f 62 69 6e 2f 65 6e 76 20  #! /usr/bin/env 
0010: 62 61 73 68 0a 0a 23 20 43 6c 65 61 6e 20 76 61  bash..# Clean va
0020: 72 69 61 62 6c 65 73 20 77 68 69 63 68 20 77 69  riables which wi
0030: 6c 6c 20 69 6e 74 65 72 66 65 72 65 20 77 69 74  ll interfere wit
0040: 68 20 74 68 65 20 62 75 69 6c 64 0a 75 6e 73 65  h the build.unse
0050: 74 20 4d 41 4b 45 46 4c 41 47 53 20 44 45 53 54  t MAKEFLAGS DEST
0060: 44 49 52 0a 0a 23 20 44 65 74 65 72 6d 69 6e 65  DIR..# Determine
0070: 20 61 70 70 72 6f 70 72 69 61 74 65 20 6d 6f 64   appropriate mod
0080: 65 0a 6d 6f 64 65 3d 22 62 75 69 6c 64 22 0a 63  e.mode="build".c
0090: 61 73 65 20 22 24 31 22 20 69 6e 0a 09 63 6c 65  ase "$1" in..cle
00a0: 61 6e 7c 64 69 73 74 63 6c 65 61 6e 7c 62 75 69  an|distclean|bui
00b0: 6c 64 7c 72 65 74 72 79 29 0a 09 09 6d 6f 64 65  ld|retry)...mode
00c0: 3d 22 24 31 22 0a 09 09 73 68 69 66 74 0a 09 09  ="$1"...shift...
00d0: 3b 3b 0a 65 73 61 63 0a 0a 23 20 44 65 74 65 72  ;;.esac..# Deter
00e0: 6d 69 6e 65 20 77 68 69 63 68 20 54 63 6c 20 76  mine which Tcl v
00f0: 65 72 73 69 6f 6e 20 74 6f 20 62 75 69 6c 64 0a  ersion to build.
0100: 54 43 4c 56 45 52 53 3d 22 38 2e 36 2e 33 22 0a  TCLVERS="8.6.3".
0110: 69 66 20 65 63 68 6f 20 22 24 31 22 20 7c 20 67  if echo "$1" | g
0120: 72 65 70 20 27 5e 5b 30 2d 39 5d 5b 30 2d 39 5d  rep '^[0-9][0-9]
0130: 2a 5c 2e 27 20 3e 2f 64 65 76 2f 6e 75 6c 6c 20  *\.' >/dev/null 
0140: 7c 7c 20 65 63 68 6f 20 22 24 31 22 20 7c 20 65  || echo "$1" | e
0150: 67 72 65 70 20 27 5e 28 63 76 73 7c 66 6f 73 73  grep '^(cvs|foss
0160: 69 6c 29 5f 27 20 3e 2f 64 65 76 2f 6e 75 6c 6c  il)_' >/dev/null
0170: 3b 20 74 68 65 6e 0a 09 54 43 4c 56 45 52 53 3d  ; then..TCLVERS=
0180: 22 24 31 22 0a 0a 09 73 68 69 66 74 0a 66 69 0a  "$1"...shift.fi.
0190: 65 78 70 6f 72 74 20 54 43 4c 56 45 52 53 0a 0a  export TCLVERS..
01a0: 23 20 56 65 72 69 66 79 20 74 68 61 74 20 22 70  # Verify that "p
01b0: 72 65 2e 73 68 22 20 68 61 73 20 62 65 65 6e 20  re.sh" has been 
01c0: 72 75 6e 20 69 66 20 74 68 69 73 20 69 73 20 61  run if this is a
01d0: 20 64 65 76 65 6c 6f 70 6d 65 6e 74 20 73 6e 61   development sna
01e0: 70 73 68 6f 74 20 6f 66 0a 23 20 4b 69 74 43 72  pshot of.# KitCr
01f0: 65 61 74 6f 72 0a 69 66 20 5b 20 2d 66 20 27 62  eator.if [ -f 'b
0200: 75 69 6c 64 2f 70 72 65 2e 73 68 27 20 5d 3b 20  uild/pre.sh' ]; 
0210: 74 68 65 6e 0a 09 69 66 20 21 20 66 69 6e 64 20  then..if ! find 
0220: 27 6b 69 74 73 68 2f 62 75 69 6c 64 73 72 63 2f  'kitsh/buildsrc/
0230: 27 20 2d 6e 61 6d 65 20 63 6f 6e 66 69 67 75 72  ' -name configur
0240: 65 20 2d 74 79 70 65 20 66 20 32 3e 2f 64 65 76  e -type f 2>/dev
0250: 2f 6e 75 6c 6c 20 7c 20 67 72 65 70 20 63 6f 6e  /null | grep con
0260: 66 69 67 75 72 65 20 3e 2f 64 65 76 2f 6e 75 6c  figure >/dev/nul
0270: 6c 3b 20 74 68 65 6e 0a 09 09 65 63 68 6f 20 22  l; then...echo "
0280: 50 6c 65 61 73 65 20 72 65 6d 65 6d 62 65 72 20  Please remember 
0290: 74 6f 20 72 75 6e 20 27 62 75 69 6c 64 2f 70 72  to run 'build/pr
02a0: 65 2e 73 68 27 20 69 66 20 79 6f 75 20 65 78 70  e.sh' if you exp
02b0: 65 63 74 20 74 68 69 73 20 62 75 69 6c 64 20 74  ect this build t
02c0: 6f 20 77 6f 72 6b 2e 22 20 3e 26 32 0a 09 66 69  o work." >&2..fi
02d0: 0a 66 69 0a 0a 23 20 44 65 66 69 6e 65 20 74 68  .fi..# Define th
02e0: 65 20 6c 69 73 74 20 6f 66 20 61 6c 6c 20 70 61  e list of all pa
02f0: 63 6b 61 67 65 73 2c 20 66 6f 72 20 63 6c 65 61  ckages, for clea
0300: 6e 69 6e 67 20 70 75 72 70 6f 73 65 73 0a 4b 49  ning purposes.KI
0310: 54 43 52 45 41 54 4f 52 5f 41 4c 4c 50 4b 47 53  TCREATOR_ALLPKGS
0320: 3d 22 6b 69 74 73 68 20 74 63 6c 20 74 63 6c 76  ="kitsh tcl tclv
0330: 66 73 20 7a 6c 69 62 20 74 6b 20 69 74 63 6c 20  fs zlib tk itcl 
0340: 6d 6b 34 74 63 6c 20 74 68 72 65 61 64 20 64 62  mk4tcl thread db
0350: 75 73 20 74 6c 73 20 74 63 6c 78 20 74 63 63 34  us tls tclx tcc4
0360: 74 63 6c 20 74 63 6c 6c 69 62 22 0a 0a 23 20 41  tcl tcllib"..# A
0370: 6c 77 61 79 73 20 72 65 62 75 69 6c 64 20 6b 69  lways rebuild ki
0380: 74 73 68 0a 72 6d 20 2d 66 20 22 6b 69 74 73 68  tsh.rm -f "kitsh
0390: 2f 2e 73 75 63 63 65 73 73 22 0a 66 6f 72 20 70  /.success".for p
03a0: 6b 67 20 69 6e 20 24 7b 4b 49 54 43 52 45 41 54  kg in ${KITCREAT
03b0: 4f 52 5f 41 4c 4c 50 4b 47 53 7d 20 24 7b 4b 49  OR_ALLPKGS} ${KI
03c0: 54 43 52 45 41 54 4f 52 5f 50 4b 47 53 7d 3b 20  TCREATOR_PKGS}; 
03d0: 64 6f 0a 09 69 66 20 5b 20 22 24 7b 6d 6f 64 65  do..if [ "${mode
03e0: 7d 22 20 21 3d 20 22 72 65 74 72 79 22 20 2d 6f  }" != "retry" -o
03f0: 20 21 20 2d 66 20 22 24 7b 70 6b 67 7d 2f 2e 73   ! -f "${pkg}/.s
0400: 75 63 63 65 73 73 22 20 5d 3b 20 74 68 65 6e 0a  uccess" ]; then.
0410: 09 09 72 6d 20 2d 66 20 22 24 7b 70 6b 67 7d 2f  ..rm -f "${pkg}/
0420: 62 75 69 6c 64 2e 6c 6f 67 22 20 22 24 7b 70 6b  build.log" "${pk
0430: 67 7d 2f 2e 73 75 63 63 65 73 73 22 0a 09 09 72  g}/.success"...r
0440: 6d 20 2d 72 66 20 22 24 7b 70 6b 67 7d 2f 6f 75  m -rf "${pkg}/ou
0450: 74 22 20 22 24 7b 70 6b 67 7d 2f 69 6e 73 74 22  t" "${pkg}/inst"
0460: 20 22 24 7b 70 6b 67 7d 2f 62 75 69 6c 64 22 0a   "${pkg}/build".
0470: 0a 09 09 72 6d 20 2d 72 66 20 22 24 7b 70 6b 67  ...rm -rf "${pkg
0480: 7d 2f 73 72 63 22 2f 74 6d 70 2d 2a 0a 09 66 69  }/src"/tmp-*..fi
0490: 0a 0a 09 69 66 20 5b 20 22 24 7b 6d 6f 64 65 7d  ...if [ "${mode}
04a0: 22 20 3d 20 22 64 69 73 74 63 6c 65 61 6e 22 20  " = "distclean" 
04b0: 5d 3b 20 74 68 65 6e 0a 09 09 72 6d 20 2d 72 66  ]; then...rm -rf
04c0: 20 22 24 7b 70 6b 67 7d 2f 73 72 63 22 0a 09 66   "${pkg}/src"..f
04d0: 69 0a 64 6f 6e 65 0a 0a 23 20 57 65 27 72 65 20  i.done..# We're 
04e0: 61 6c 6c 20 64 6f 6e 65 20 69 66 20 77 65 27 72  all done if we'r
04f0: 65 20 69 6e 20 63 6c 65 61 6e 20 6f 72 20 64 69  e in clean or di
0500: 73 74 63 6c 65 61 6e 20 6d 6f 64 65 0a 69 66 20  stclean mode.if 
0510: 5b 20 22 24 7b 6d 6f 64 65 7d 22 20 3d 20 22 63  [ "${mode}" = "c
0520: 6c 65 61 6e 22 20 2d 6f 20 22 24 7b 6d 6f 64 65  lean" -o "${mode
0530: 7d 22 20 3d 20 22 64 69 73 74 63 6c 65 61 6e 22  }" = "distclean"
0540: 20 5d 3b 20 74 68 65 6e 0a 09 72 6d 20 2d 66 20   ]; then..rm -f 
0550: 74 63 6c 6b 69 74 2d 2a 0a 09 72 6d 20 2d 66 20  tclkit-*..rm -f 
0560: 6c 69 62 74 63 6c 6b 69 74 2a 2e 2a 0a 0a 09 65  libtclkit*.*...e
0570: 78 69 74 20 30 0a 66 69 0a 0a 23 20 41 64 64 20  xit 0.fi..# Add 
0580: 70 61 63 6b 61 67 65 73 20 69 6d 70 6c 69 65 64  packages implied
0590: 20 62 79 20 74 68 65 20 61 64 64 69 74 69 6f 6e   by the addition
05a0: 61 6c 20 61 72 67 75 6d 65 6e 74 73 0a 69 66 20  al arguments.if 
05b0: 5b 20 2d 7a 20 22 24 7b 4b 49 54 43 52 45 41 54  [ -z "${KITCREAT
05c0: 4f 52 5f 50 4b 47 53 7d 22 20 5d 3b 20 74 68 65  OR_PKGS}" ]; the
05d0: 6e 0a 09 4b 49 54 43 52 45 41 54 4f 52 5f 50 4b  n..KITCREATOR_PK
05e0: 47 53 3d 22 74 6b 20 69 74 63 6c 20 6d 6b 34 74  GS="tk itcl mk4t
05f0: 63 6c 22 0a 66 69 0a 0a 43 4f 4e 46 49 47 55 52  cl".fi..CONFIGUR
0600: 45 45 58 54 52 41 3d 22 24 40 22 0a 65 78 70 6f  EEXTRA="$@".expo
0610: 72 74 20 43 4f 4e 46 49 47 55 52 45 45 58 54 52  rt CONFIGUREEXTR
0620: 41 0a 0a 69 66 20 65 63 68 6f 20 22 20 24 7b 43  A..if echo " ${C
0630: 4f 4e 46 49 47 55 52 45 45 58 54 52 41 7d 20 22  ONFIGUREEXTRA} "
0640: 20 7c 20 67 72 65 70 20 27 20 2d 2d 65 6e 61 62   | grep ' --enab
0650: 6c 65 2d 74 68 72 65 61 64 73 27 20 3e 2f 64 65  le-threads' >/de
0660: 76 2f 6e 75 6c 6c 20 32 3e 2f 64 65 76 2f 6e 75  v/null 2>/dev/nu
0670: 6c 6c 3b 20 74 68 65 6e 0a 09 4b 49 54 43 52 45  ll; then..KITCRE
0680: 41 54 4f 52 5f 50 4b 47 53 3d 22 24 7b 4b 49 54  ATOR_PKGS="${KIT
0690: 43 52 45 41 54 4f 52 5f 50 4b 47 53 7d 20 74 68  CREATOR_PKGS} th
06a0: 72 65 61 64 22 0a 66 69 0a 0a 23 20 44 65 74 65  read".fi..# Dete
06b0: 72 6d 69 6e 65 20 63 72 6f 73 73 2d 63 6f 6d 70  rmine cross-comp
06c0: 69 6c 65 20 73 74 61 74 75 73 0a 68 6f 73 74 5f  ile status.host_
06d0: 6f 73 3d 22 24 28 65 63 68 6f 20 22 20 24 7b 43  os="$(echo " ${C
06e0: 4f 4e 46 49 47 55 52 45 45 58 54 52 41 7d 20 22  ONFIGUREEXTRA} "
06f0: 20 7c 20 73 65 64 20 27 73 40 5e 2e 2a 20 2d 2d   | sed 's@^.* --
0700: 68 6f 73 74 3d 5c 28 5b 5e 20 5d 2a 5c 29 20 2e  host=\([^ ]*\) .
0710: 2a 24 40 5c 31 40 0a 74 20 78 0a 64 0a 3a 78 27  *$@\1@.t x.d.:x'
0720: 29 22 0a 62 75 69 6c 64 5f 6f 73 3d 22 24 28 65  )".build_os="$(e
0730: 63 68 6f 20 22 20 24 7b 43 4f 4e 46 49 47 55 52  cho " ${CONFIGUR
0740: 45 45 58 54 52 41 7d 20 22 20 7c 20 73 65 64 20  EEXTRA} " | sed 
0750: 27 73 40 5e 2e 2a 20 2d 2d 62 75 69 6c 64 3d 5c  's@^.* --build=\
0760: 28 5b 5e 20 5d 2a 5c 29 20 2e 2a 24 40 5c 31 40  ([^ ]*\) .*$@\1@
0770: 0a 74 20 78 0a 64 0a 3a 78 27 29 22 0a 0a 69 66  .t x.d.:x')"..if
0780: 20 5b 20 22 24 7b 68 6f 73 74 5f 6f 73 7d 22 20   [ "${host_os}" 
0790: 21 3d 20 22 24 7b 62 75 69 6c 64 5f 6f 73 7d 22  != "${build_os}"
07a0: 20 2d 61 20 2d 6e 20 22 24 7b 68 6f 73 74 5f 6f   -a -n "${host_o
07b0: 73 7d 22 20 5d 3b 20 74 68 65 6e 0a 09 4b 43 5f  s}" ]; then..KC_
07c0: 43 52 4f 53 53 43 4f 4d 50 49 4c 45 3d 27 31 27  CROSSCOMPILE='1'
07d0: 0a 09 4b 43 5f 43 52 4f 53 53 43 4f 4d 50 49 4c  ..KC_CROSSCOMPIL
07e0: 45 5f 48 4f 53 54 5f 4f 53 3d 22 24 7b 68 6f 73  E_HOST_OS="${hos
07f0: 74 5f 6f 73 7d 22 0a 65 6c 73 65 0a 09 4b 43 5f  t_os}".else..KC_
0800: 43 52 4f 53 53 43 4f 4d 50 49 4c 45 3d 27 30 27  CROSSCOMPILE='0'
0810: 0a 09 4b 43 5f 43 52 4f 53 53 43 4f 4d 50 49 4c  ..KC_CROSSCOMPIL
0820: 45 5f 48 4f 53 54 5f 4f 53 3d 27 27 0a 66 69 0a  E_HOST_OS=''.fi.
0830: 65 78 70 6f 72 74 20 4b 43 5f 43 52 4f 53 53 43  export KC_CROSSC
0840: 4f 4d 50 49 4c 45 20 4b 43 5f 43 52 4f 53 53 43  OMPILE KC_CROSSC
0850: 4f 4d 50 49 4c 45 5f 48 4f 53 54 5f 4f 53 0a 0a  OMPILE_HOST_OS..
0860: 23 20 53 65 74 20 64 65 66 61 75 6c 74 20 74 61  # Set default ta
0870: 72 67 65 74 0a 4b 49 54 54 41 52 47 45 54 3d 22  rget.KITTARGET="
0880: 6b 69 74 73 68 22 0a 65 78 70 6f 72 74 20 4b 49  kitsh".export KI
0890: 54 54 41 52 47 45 54 0a 0a 23 20 46 69 78 20 75  TTARGET..# Fix u
08a0: 70 20 70 61 63 6b 61 67 65 20 6c 69 73 74 0a 23  p package list.#
08b0: 23 20 49 66 20 62 75 69 6c 64 69 6e 67 20 4b 69  # If building Ki
08c0: 74 44 4c 4c 2c 20 64 65 66 69 6e 65 20 69 74 20  tDLL, define it 
08d0: 61 73 20 6f 75 72 20 74 61 72 67 65 74 0a 69 66  as our target.if
08e0: 20 65 63 68 6f 20 22 20 24 7b 4b 49 54 43 52 45   echo " ${KITCRE
08f0: 41 54 4f 52 5f 50 4b 47 53 7d 20 22 20 7c 20 67  ATOR_PKGS} " | g
0900: 72 65 70 20 27 20 6b 69 74 64 6c 6c 20 27 20 3e  rep ' kitdll ' >
0910: 2f 64 65 76 2f 6e 75 6c 6c 20 32 3e 2f 64 65 76  /dev/null 2>/dev
0920: 2f 6e 75 6c 6c 3b 20 74 68 65 6e 0a 09 4b 49 54  /null; then..KIT
0930: 43 52 45 41 54 4f 52 5f 50 4b 47 53 3d 22 24 28  CREATOR_PKGS="$(
0940: 65 63 68 6f 20 22 20 24 7b 4b 49 54 43 52 45 41  echo " ${KITCREA
0950: 54 4f 52 5f 50 4b 47 53 7d 20 22 20 7c 20 73 65  TOR_PKGS} " | se
0960: 64 20 27 73 40 20 6b 69 74 64 6c 6c 20 40 20 40  d 's@ kitdll @ @
0970: 67 3b 73 40 5e 20 20 2a 40 40 3b 73 40 20 20 2a  g;s@^  *@@;s@  *
0980: 24 40 40 3b 73 40 20 20 20 2a 40 20 40 67 27 29  $@@;s@   *@ @g')
0990: 22 0a 09 4b 49 54 54 41 52 47 45 54 3d 22 6b 69  "..KITTARGET="ki
09a0: 74 64 6c 6c 22 0a 66 69 0a 0a 23 20 49 66 20 74  tdll".fi..# If t
09b0: 68 65 20 75 73 65 72 20 6d 61 6e 75 61 6c 6c 79  he user manually
09c0: 20 72 65 71 75 65 73 74 65 64 20 22 2d 2d 65 6e   requested "--en
09d0: 61 62 6c 65 2d 6b 69 74 64 6c 6c 22 2c 20 6d 61  able-kitdll", ma
09e0: 6b 65 20 69 74 20 73 6f 0a 69 66 20 65 63 68 6f  ke it so.if echo
09f0: 20 22 78 20 24 40 20 22 20 7c 20 67 72 65 70 20   "x $@ " | grep 
0a00: 27 20 5b 2d 5d 5b 2d 5d 65 6e 61 62 6c 65 2d 6b  ' [-][-]enable-k
0a10: 69 74 64 6c 6c 20 27 20 3e 2f 64 65 76 2f 6e 75  itdll ' >/dev/nu
0a20: 6c 6c 20 32 3e 2f 64 65 76 2f 6e 75 6c 6c 3b 20  ll 2>/dev/null; 
0a30: 74 68 65 6e 0a 09 4b 49 54 54 41 52 47 45 54 3d  then..KITTARGET=
0a40: 22 6b 69 74 64 6c 6c 22 0a 66 69 0a 0a 23 23 20  "kitdll".fi..## 
0a50: 49 66 20 62 75 69 6c 64 69 6e 67 20 4b 69 74 44  If building KitD
0a60: 4c 4c 20 61 6e 64 20 54 6b 2c 20 6d 75 73 74 20  LL and Tk, must 
0a70: 64 6f 20 54 6b 20 73 74 61 74 69 63 61 6c 6c 79  do Tk statically
0a80: 0a 23 23 23 20 28 57 65 6c 6c 2c 20 77 65 20 64  .### (Well, we d
0a90: 6f 6e 27 74 20 48 41 56 45 20 74 6f 2c 20 62 75  on't HAVE to, bu
0aa0: 74 20 69 74 20 77 6f 75 6c 64 20 64 65 66 65 61  t it would defea
0ab0: 74 20 6d 75 63 68 20 6f 66 20 74 68 65 20 70 75  t much of the pu
0ac0: 72 70 6f 73 65 29 0a 69 66 20 5b 20 22 24 7b 4b  rpose).if [ "${K
0ad0: 49 54 54 41 52 47 45 54 7d 22 20 3d 20 22 6b 69  ITTARGET}" = "ki
0ae0: 74 64 6c 6c 22 20 5d 3b 20 74 68 65 6e 0a 09 69  tdll" ]; then..i
0af0: 66 20 65 63 68 6f 20 22 20 24 7b 4b 49 54 43 52  f echo " ${KITCR
0b00: 45 41 54 4f 52 5f 50 4b 47 53 7d 20 22 20 7c 20  EATOR_PKGS} " | 
0b10: 67 72 65 70 20 27 20 74 6b 20 27 20 3e 2f 64 65  grep ' tk ' >/de
0b20: 76 2f 6e 75 6c 6c 20 32 3e 2f 64 65 76 2f 6e 75  v/null 2>/dev/nu
0b30: 6c 6c 3b 20 74 68 65 6e 0a 09 09 69 66 20 5b 20  ll; then...if [ 
0b40: 22 24 7b 53 54 41 54 49 43 54 4b 7d 22 20 21 3d  "${STATICTK}" !=
0b50: 20 22 31 22 20 2d 61 20 22 24 7b 53 54 41 54 49   "1" -a "${STATI
0b60: 43 54 4b 7d 22 20 21 3d 20 22 2d 31 22 20 5d 3b  CTK}" != "-1" ];
0b70: 20 74 68 65 6e 0a 09 09 09 65 63 68 6f 20 27 57   then....echo 'W
0b80: 61 72 6e 69 6e 67 3a 20 4c 69 6e 6b 69 6e 67 20  arning: Linking 
0b90: 54 6b 20 73 74 61 74 69 63 61 6c 6c 79 20 62 65  Tk statically be
0ba0: 63 61 75 73 65 20 79 6f 75 20 61 72 65 20 62 75  cause you are bu
0bb0: 69 6c 64 69 6e 67 20 4b 69 74 44 4c 4c 27 20 32  ilding KitDLL' 2
0bc0: 3e 26 31 0a 09 09 09 65 63 68 6f 20 27 20 20 20  >&1....echo '   
0bd0: 20 20 20 20 20 20 53 65 74 20 53 54 41 54 49 43        Set STATIC
0be0: 54 4b 20 74 6f 20 2d 31 20 69 66 20 79 6f 75 20  TK to -1 if you 
0bf0: 72 65 61 6c 6c 79 20 77 61 6e 74 20 74 6f 20 6c  really want to l
0c00: 69 6e 6b 20 54 6b 20 64 79 6e 61 6d 69 63 61 6c  ink Tk dynamical
0c10: 6c 79 2e 27 20 3e 26 32 0a 0a 09 09 09 53 54 41  ly.' >&2.....STA
0c20: 54 49 43 54 4b 3d 22 31 22 0a 09 09 09 65 78 70  TICTK="1"....exp
0c30: 6f 72 74 20 53 54 41 54 49 43 54 4b 0a 09 09 66  ort STATICTK...f
0c40: 69 0a 09 66 69 0a 0a 09 69 66 20 65 63 68 6f 20  i..fi...if echo 
0c50: 22 20 24 7b 4b 49 54 43 52 45 41 54 4f 52 5f 50  " ${KITCREATOR_P
0c60: 4b 47 53 7d 20 22 20 7c 20 67 72 65 70 20 27 20  KGS} " | grep ' 
0c70: 6d 6b 34 74 63 6c 20 27 20 3e 2f 64 65 76 2f 6e  mk4tcl ' >/dev/n
0c80: 75 6c 6c 20 32 3e 2f 64 65 76 2f 6e 75 6c 6c 3b  ull 2>/dev/null;
0c90: 20 74 68 65 6e 0a 09 09 69 66 20 5b 20 2d 7a 20   then...if [ -z 
0ca0: 22 24 7b 53 54 41 54 49 43 4d 4b 34 7d 22 20 5d  "${STATICMK4}" ]
0cb0: 3b 20 74 68 65 6e 0a 09 09 09 65 63 68 6f 20 27  ; then....echo '
0cc0: 57 61 72 6e 69 6e 67 3a 20 4c 69 6e 6b 69 6e 67  Warning: Linking
0cd0: 20 4d 6b 34 74 63 6c 20 64 79 6e 61 6d 69 63 61   Mk4tcl dynamica
0ce0: 6c 6c 79 20 62 65 63 61 75 73 65 20 79 6f 75 20  lly because you 
0cf0: 61 72 65 20 62 75 69 6c 64 69 6e 67 20 4b 69 74  are building Kit
0d00: 44 4c 4c 27 20 32 3e 26 31 0a 09 09 09 65 63 68  DLL' 2>&1....ech
0d10: 6f 20 27 20 20 20 20 20 20 20 20 20 53 65 74 20  o '         Set 
0d20: 53 54 41 54 49 43 4d 4b 34 20 74 6f 20 6d 61 6b  STATICMK4 to mak
0d30: 65 20 74 68 69 73 20 6d 65 73 73 61 67 65 20 67  e this message g
0d40: 6f 20 61 77 61 79 2e 27 20 3e 26 32 0a 09 09 09  o away.' >&2....
0d50: 65 63 68 6f 20 27 20 20 20 20 20 20 20 20 20 53  echo '         S
0d60: 65 74 20 53 54 41 54 49 43 4d 4b 34 20 74 6f 20  et STATICMK4 to 
0d70: 31 20 69 66 20 79 6f 75 20 72 65 61 6c 6c 79 20  1 if you really 
0d80: 77 61 6e 74 20 74 6f 20 6c 69 6e 6b 20 4d 6b 34  want to link Mk4
0d90: 74 63 6c 20 73 74 61 74 69 63 61 6c 6c 79 20 28  tcl statically (
0da0: 6e 6f 72 6d 61 6c 20 64 65 66 61 75 6c 74 29 2e  normal default).
0db0: 27 20 3e 26 32 0a 09 09 09 65 63 68 6f 20 27 20  ' >&2....echo ' 
0dc0: 20 20 20 20 20 20 20 20 53 65 74 20 53 54 41 54          Set STAT
0dd0: 49 43 4d 4b 34 20 74 6f 20 30 20 74 6f 20 6c 69  ICMK4 to 0 to li
0de0: 6e 6b 20 4d 6b 34 74 63 6c 20 64 79 6e 61 6d 69  nk Mk4tcl dynami
0df0: 63 61 6c 6c 79 20 69 66 20 70 6f 73 73 69 62 6c  cally if possibl
0e00: 65 20 28 74 68 69 73 20 69 73 20 77 68 61 74 20  e (this is what 
0e10: 69 73 20 68 61 70 70 65 6e 69 6e 67 20 6e 6f 77  is happening now
0e20: 29 2e 27 20 3e 26 32 0a 09 09 09 65 63 68 6f 20  ).' >&2....echo 
0e30: 27 20 20 20 20 20 20 20 20 20 53 65 74 20 53 54  '         Set ST
0e40: 41 54 49 43 4d 4b 34 20 74 6f 20 2d 31 20 74 6f  ATICMK4 to -1 to
0e50: 20 62 75 69 6c 64 20 64 79 6e 61 6d 69 63 61 6c   build dynamical
0e60: 6c 79 2e 27 20 3e 26 32 0a 0a 09 09 09 53 54 41  ly.' >&2.....STA
0e70: 54 49 43 4d 4b 34 3d 22 30 22 0a 09 09 09 65 78  TICMK4="0"....ex
0e80: 70 6f 72 74 20 53 54 41 54 49 43 4d 4b 34 0a 09  port STATICMK4..
0e90: 09 66 69 0a 09 66 69 0a 66 69 0a 0a 23 20 46 69  .fi..fi.fi..# Fi
0ea0: 6e 64 20 57 69 6e 64 6f 77 73 20 72 65 73 6f 75  nd Windows resou
0eb0: 72 63 65 2d 72 65 6c 61 74 65 64 20 66 69 6c 65  rce-related file
0ec0: 73 0a 69 66 20 5b 20 2d 66 20 22 6b 69 74 2e 69  s.if [ -f "kit.i
0ed0: 63 6f 22 20 5d 3b 20 74 68 65 6e 0a 09 4b 49 54  co" ]; then..KIT
0ee0: 43 52 45 41 54 4f 52 5f 49 43 4f 4e 3d 22 24 28  CREATOR_ICON="$(
0ef0: 70 77 64 29 2f 6b 69 74 2e 69 63 6f 22 0a 65 6c  pwd)/kit.ico".el
0f00: 73 65 0a 09 4b 49 54 43 52 45 41 54 4f 52 5f 49  se..KITCREATOR_I
0f10: 43 4f 4e 3d 22 24 28 65 63 68 6f 20 22 24 28 70  CON="$(echo "$(p
0f20: 77 64 29 2f 6b 69 74 73 68 2f 62 75 69 6c 64 73  wd)/kitsh/builds
0f30: 72 63 22 2f 6b 69 74 73 68 2d 2a 2f 74 63 6c 6b  rc"/kitsh-*/tclk
0f40: 69 74 2e 69 63 6f 29 22 0a 66 69 0a 69 66 20 5b  it.ico)".fi.if [
0f50: 20 2d 66 20 22 6b 69 74 2e 72 63 22 20 5d 3b 20   -f "kit.rc" ]; 
0f60: 74 68 65 6e 0a 09 4b 49 54 43 52 45 41 54 4f 52  then..KITCREATOR
0f70: 5f 52 43 3d 22 24 28 70 77 64 29 2f 6b 69 74 2e  _RC="$(pwd)/kit.
0f80: 72 63 22 0a 65 6c 73 65 0a 09 4b 49 54 43 52 45  rc".else..KITCRE
0f90: 41 54 4f 52 5f 52 43 3d 22 24 28 65 63 68 6f 20  ATOR_RC="$(echo 
0fa0: 22 24 28 70 77 64 29 2f 6b 69 74 73 68 2f 62 75  "$(pwd)/kitsh/bu
0fb0: 69 6c 64 73 72 63 22 2f 6b 69 74 73 68 2d 2a 2f  ildsrc"/kitsh-*/
0fc0: 6b 69 74 2e 72 63 29 22 0a 66 69 0a 65 78 70 6f  kit.rc)".fi.expo
0fd0: 72 74 20 4b 49 54 43 52 45 41 54 4f 52 5f 49 43  rt KITCREATOR_IC
0fe0: 4f 4e 20 4b 49 54 43 52 45 41 54 4f 52 5f 52 43  ON KITCREATOR_RC
0ff0: 0a 0a 23 20 44 65 74 65 72 6d 69 6e 65 20 68 6f  ..# Determine ho
1000: 77 20 77 65 20 69 6e 76 6f 6b 65 20 61 20 54 63  w we invoke a Tc
1010: 6c 20 69 6e 74 65 72 70 72 65 74 65 72 0a 69 66  l interpreter.if
1020: 20 5b 20 2d 7a 20 22 24 7b 54 43 4c 53 48 5f 4e   [ -z "${TCLSH_N
1030: 41 54 49 56 45 7d 22 20 5d 3b 20 74 68 65 6e 0a  ATIVE}" ]; then.
1040: 09 54 43 4c 53 48 5f 4e 41 54 49 56 45 3d 22 66  .TCLSH_NATIVE="f
1050: 61 6c 73 65 22 0a 66 69 0a 66 6f 72 20 74 65 73  alse".fi.for tes
1060: 74 73 68 20 69 6e 20 22 24 7b 54 43 4c 53 48 5f  tsh in "${TCLSH_
1070: 4e 41 54 49 56 45 7d 22 20 74 63 6c 73 68 20 74  NATIVE}" tclsh t
1080: 63 6c 73 68 38 2e 34 20 74 63 6c 73 68 38 2e 35  clsh8.4 tclsh8.5
1090: 20 74 63 6c 73 68 38 2e 36 20 22 24 7b 54 43 4c   tclsh8.6 "${TCL
10a0: 4b 49 54 3a 2d 74 63 6c 6b 69 74 7d 22 3b 20 64  KIT:-tclkit}"; d
10b0: 6f 0a 09 69 66 20 65 63 68 6f 20 27 65 78 69 74  o..if echo 'exit
10c0: 20 30 27 20 7c 20 22 24 7b 74 65 73 74 73 68 7d   0' | "${testsh}
10d0: 22 20 3e 2f 64 65 76 2f 6e 75 6c 6c 20 32 3e 2f  " >/dev/null 2>/
10e0: 64 65 76 2f 6e 75 6c 6c 3b 20 74 68 65 6e 0a 09  dev/null; then..
10f0: 09 54 43 4c 53 48 5f 4e 41 54 49 56 45 3d 22 24  .TCLSH_NATIVE="$
1100: 7b 74 65 73 74 73 68 7d 22 0a 0a 09 09 62 72 65  {testsh}"....bre
1110: 61 6b 0a 09 66 69 0a 64 6f 6e 65 0a 65 78 70 6f  ak..fi.done.expo
1120: 72 74 20 54 43 4c 53 48 5f 4e 41 54 49 56 45 0a  rt TCLSH_NATIVE.
1130: 0a 23 20 44 6f 20 62 75 69 6c 64 0a 66 61 69 6c  .# Do build.fail
1140: 65 64 70 6b 67 73 3d 22 22 0a 62 75 69 6c 64 66  edpkgs="".buildf
1150: 61 69 6c 65 64 3d 22 30 22 0a 66 6f 72 20 70 6b  ailed="0".for pk
1160: 67 20 69 6e 20 74 63 6c 20 74 63 6c 76 66 73 20  g in tcl tclvfs 
1170: 7a 6c 69 62 20 24 7b 4b 49 54 43 52 45 41 54 4f  zlib ${KITCREATO
1180: 52 5f 50 4b 47 53 7d 20 6b 69 74 73 68 3b 20 64  R_PKGS} kitsh; d
1190: 6f 0a 09 66 61 69 6c 65 64 3d 22 30 22 0a 09 69  o..failed="0"..i
11a0: 66 20 5b 20 2d 66 20 22 24 7b 70 6b 67 7d 2f 2e  f [ -f "${pkg}/.
11b0: 73 75 63 63 65 73 73 22 20 5d 3b 20 74 68 65 6e  success" ]; then
11c0: 0a 09 09 65 63 68 6f 20 2d 6e 20 22 53 6b 69 70  ...echo -n "Skip
11d0: 70 69 6e 67 20 24 7b 70 6b 67 7d 20 2e 2e 2e 22  ping ${pkg} ..."
11e0: 0a 09 65 6c 73 65 0a 09 09 65 63 68 6f 20 2d 6e  ..else...echo -n
11f0: 20 22 42 75 69 6c 64 69 6e 67 20 24 7b 70 6b 67   "Building ${pkg
1200: 7d 20 2e 2e 2e 22 0a 0a 09 09 28 0a 09 09 09 63  } ..."....(....c
1210: 64 20 22 24 7b 70 6b 67 7d 22 20 3e 2f 64 65 76  d "${pkg}" >/dev
1220: 2f 6e 75 6c 6c 20 32 3e 2f 64 65 76 2f 6e 75 6c  /null 2>/dev/nul
1230: 6c 20 7c 7c 20 65 78 69 74 20 31 0a 0a 09 09 09  l || exit 1.....
1240: 62 75 69 6c 64 5f 73 63 72 69 70 74 3d 27 2e 2f  build_script='./
1250: 62 75 69 6c 64 2e 73 68 27 0a 09 09 09 69 66 20  build.sh'....if 
1260: 5b 20 2d 78 20 27 6b 69 74 63 72 65 61 74 6f 72  [ -x 'kitcreator
1270: 2d 62 75 69 6c 64 2e 73 68 27 20 5d 3b 20 74 68  -build.sh' ]; th
1280: 65 6e 0a 09 09 09 09 62 75 69 6c 64 5f 73 63 72  en.....build_scr
1290: 69 70 74 3d 27 2e 2f 6b 69 74 63 72 65 61 74 6f  ipt='./kitcreato
12a0: 72 2d 62 75 69 6c 64 2e 73 68 27 0a 09 09 09 66  r-build.sh'....f
12b0: 69 0a 09 09 09 22 24 7b 62 75 69 6c 64 5f 73 63  i...."${build_sc
12c0: 72 69 70 74 7d 22 20 33 3e 26 31 20 34 3e 26 32  ript}" 3>&1 4>&2
12d0: 20 3e 20 62 75 69 6c 64 2e 6c 6f 67 20 32 3e 26   > build.log 2>&
12e0: 31 20 7c 7c 20 65 78 69 74 20 31 0a 09 09 29 20  1 || exit 1...) 
12f0: 7c 7c 20 66 61 69 6c 65 64 3d 22 31 22 0a 09 66  || failed="1"..f
1300: 69 0a 0a 09 69 66 20 5b 20 22 24 7b 66 61 69 6c  i...if [ "${fail
1310: 65 64 7d 22 20 3d 20 22 31 22 20 5d 3b 20 74 68  ed}" = "1" ]; th
1320: 65 6e 0a 09 09 65 63 68 6f 20 22 20 66 61 69 6c  en...echo " fail
1330: 65 64 2e 22 0a 09 09 66 61 69 6c 65 64 70 6b 67  ed."...failedpkg
1340: 73 3d 22 24 7b 66 61 69 6c 65 64 70 6b 67 73 7d  s="${failedpkgs}
1350: 20 24 7b 70 6b 67 7d 22 0a 09 65 6c 73 65 0a 09   ${pkg}"..else..
1360: 09 65 63 68 6f 20 22 20 64 6f 6e 65 2e 22 0a 09  .echo " done."..
1370: 66 69 0a 0a 09 63 61 73 65 20 22 24 7b 70 6b 67  fi...case "${pkg
1380: 7d 22 20 69 6e 0a 09 09 74 63 6c 29 0a 09 09 09  }" in...tcl)....
1390: 54 43 4c 43 4f 4e 46 49 47 44 49 52 3d 24 28 66  TCLCONFIGDIR=$(f
13a0: 69 6e 64 20 22 24 28 70 77 64 29 2f 74 63 6c 2f  ind "$(pwd)/tcl/
13b0: 62 75 69 6c 64 22 20 2d 6e 61 6d 65 20 74 63 6c  build" -name tcl
13c0: 43 6f 6e 66 69 67 2e 73 68 20 7c 20 68 65 61 64  Config.sh | head
13d0: 20 2d 31 20 7c 20 73 65 64 20 27 73 40 2f 5b 5e   -1 | sed 's@/[^
13e0: 2f 5d 2a 24 40 40 27 29 0a 09 09 09 54 43 4c 43  /]*$@@')....TCLC
13f0: 4f 4e 46 49 47 44 49 52 54 41 49 4c 3d 22 24 28  ONFIGDIRTAIL="$(
1400: 62 61 73 65 6e 61 6d 65 20 22 24 7b 54 43 4c 43  basename "${TCLC
1410: 4f 4e 46 49 47 44 49 52 7d 22 29 22 0a 09 09 09  ONFIGDIR}")"....
1420: 65 78 70 6f 72 74 20 54 43 4c 43 4f 4e 46 49 47  export TCLCONFIG
1430: 44 49 52 20 54 43 4c 43 4f 4e 46 49 47 44 49 52  DIR TCLCONFIGDIR
1440: 54 41 49 4c 0a 09 09 09 3b 3b 0a 09 65 73 61 63  TAIL....;;..esac
1450: 0a 0a 09 69 66 20 5b 20 22 24 7b 66 61 69 6c 65  ...if [ "${faile
1460: 64 7d 22 20 3d 20 22 31 22 20 5d 3b 20 74 68 65  d}" = "1" ]; the
1470: 6e 0a 09 09 62 75 69 6c 64 66 61 69 6c 65 64 3d  n...buildfailed=
1480: 22 31 22 0a 09 65 6c 73 65 0a 09 09 74 6f 75 63  "1"..else...touc
1490: 68 20 22 24 7b 70 6b 67 7d 2f 2e 73 75 63 63 65  h "${pkg}/.succe
14a0: 73 73 22 0a 09 66 69 0a 64 6f 6e 65 0a 0a 69 66  ss"..fi.done..if
14b0: 20 5b 20 2d 6e 20 22 24 7b 66 61 69 6c 65 64 70   [ -n "${failedp
14c0: 6b 67 73 7d 22 20 5d 3b 20 74 68 65 6e 0a 09 65  kgs}" ]; then..e
14d0: 63 68 6f 20 22 46 61 69 6c 65 64 20 74 6f 20 62  cho "Failed to b
14e0: 75 69 6c 64 3a 24 7b 66 61 69 6c 65 64 70 6b 67  uild:${failedpkg
14f0: 73 7d 22 0a 66 69 0a 0a 69 66 20 5b 20 22 24 7b  s}".fi..if [ "${
1500: 62 75 69 6c 64 66 61 69 6c 65 64 7d 22 20 21 3d  buildfailed}" !=
1510: 20 22 30 22 20 5d 3b 20 74 68 65 6e 0a 09 65 63   "0" ]; then..ec
1520: 68 6f 20 27 57 41 52 4e 49 4e 47 3a 20 42 75 69  ho 'WARNING: Bui
1530: 6c 64 20 69 73 20 6c 69 6b 65 6c 79 20 69 6e 63  ld is likely inc
1540: 6f 6d 70 6c 65 74 65 20 6f 72 20 66 61 69 6c 65  omplete or faile
1550: 64 2e 27 20 3e 26 32 0a 66 69 0a 0a 63 70 20 27  d.' >&2.fi..cp '
1560: 6b 69 74 73 68 2f 62 75 69 6c 64 27 2f 6b 69 74  kitsh/build'/kit
1570: 73 68 2d 2a 2f 6c 69 62 74 63 6c 6b 69 74 2a 20  sh-*/libtclkit* 
1580: 2e 20 3e 2f 64 65 76 2f 6e 75 6c 6c 20 32 3e 2f  . >/dev/null 2>/
1590: 64 65 76 2f 6e 75 6c 6c 0a 63 70 20 27 6b 69 74  dev/null.cp 'kit
15a0: 73 68 2f 62 75 69 6c 64 27 2f 6b 69 74 73 68 2d  sh/build'/kitsh-
15b0: 2a 2f 6b 69 74 20 22 74 63 6c 6b 69 74 2d 24 7b  */kit "tclkit-${
15c0: 54 43 4c 56 45 52 53 7d 22 20 3e 2f 64 65 76 2f  TCLVERS}" >/dev/
15d0: 6e 75 6c 6c 20 32 3e 2f 64 65 76 2f 6e 75 6c 6c  null 2>/dev/null
15e0: 0a 0a 66 6f 72 20 70 6f 73 74 73 63 72 69 70 74  ..for postscript
15f0: 20 69 6e 20 63 6f 6d 6d 6f 6e 2f 70 6f 73 74 2f   in common/post/
1600: 2a 3b 20 64 6f 0a 09 69 66 20 5b 20 21 20 2d 66  *; do..if [ ! -f
1610: 20 22 24 7b 70 6f 73 74 73 63 72 69 70 74 7d 22   "${postscript}"
1620: 20 5d 3b 20 74 68 65 6e 0a 09 09 63 6f 6e 74 69   ]; then...conti
1630: 6e 75 65 0a 09 66 69 0a 0a 09 22 24 7b 70 6f 73  nue..fi..."${pos
1640: 74 73 63 72 69 70 74 7d 22 0a 64 6f 6e 65 0a 0a  tscript}".done..
1650: 65 78 69 74 20 22 24 7b 62 75 69 6c 64 66 61 69  exit "${buildfai
1660: 6c 65 64 7d 22 0a                                led}".